org.apache.lucene.analysis

## Class Analyzer

- java.lang.Object
- - org.apache.lucene.analysis.Analyzer

- Direct Known Subclasses:
    ArabicAnalyzer, BrazilianAnalyzer, ChineseAnalyzer, CJKAnalyzer, CollationKeyAnalyzer, CzechAnalyzer, DutchAnalyzer, FrenchAnalyzer, GermanAnalyzer, GreekAnalyzer, ICUCollationKeyAnalyzer, KeywordAnalyzer, PatternAnalyzer, PerFieldAnalyzerWrapper, PersianAnalyzer, QueryAutoStopWordAnalyzer, RussianAnalyzer, ShingleAnalyzerWrapper, SimpleAnalyzer, SmartChineseAnalyzer, SnowballAnalyzer, StandardAnalyzer, StopAnalyzer, ThaiAnalyzer, WhitespaceAnalyzer

      public abstract class Analyzer
      extends java.lang.Object

  An Analyzer builds TokenStreams, which analyze text. It thus represents a policy for extracting index terms from text.

  Typical implementations first build a Tokenizer, which breaks the stream of characters from the Reader into raw Tokens. One or more TokenFilters may then be applied to the output of the Tokenizer.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `overridesTokenStreamMethod`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Analyzer()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Frees persistent resources used by this Analyzer
    `int` | `getOffsetGap(Fieldable field)` Just like `getPositionIncrementGap(java.lang.String)`, except for Token offsets instead.
    `int` | `getPositionIncrementGap(java.lang.String fieldName)` Invoked before indexing a Fieldable instance if terms have already been added to that field.
    `protected java.lang.Object` | `getPreviousTokenStream()` Used by Analyzers that implement reusableTokenStream to retrieve previously saved TokenStreams for re-use by the same thread.
    `TokenStream` | `reusableTokenStream(java.lang.String fieldName, java.io.Reader reader)` Creates a TokenStream that is allowed to be re-used from the previous time that the same thread called this method.
    `protected void` | `setOverridesTokenStreamMethod(java.lang.Class baseClass)` Deprecated. This is only present to preserve back-compat of classes that subclass a core analyzer and override tokenStream but not reusableTokenStream
    `protected void` | `setPreviousTokenStream(java.lang.Object obj)` Used by Analyzers that implement reusableTokenStream to save a TokenStream for later re-use by the same thread.
    `abstract TokenStream` | `tokenStream(java.lang.String fieldName, java.io.Reader reader)` Creates a TokenStream which tokenizes all the text in the provided Reader.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### overridesTokenStreamMethod

          protected boolean overridesTokenStreamMethod

  - ### Constructor Detail

    - #### Analyzer

          public Analyzer()

  - ### Method Detail

    - #### tokenStream

          public abstract TokenStream tokenStream(java.lang.String fieldName,
                                                  java.io.Reader reader)

      Creates a TokenStream which tokenizes all the text in the provided Reader. Must be able to handle null field name for backward compatibility.

    - #### reusableTokenStream

          public TokenStream reusableTokenStream(java.lang.String fieldName,
                                                 java.io.Reader reader)
                                          throws java.io.IOException

      Creates a TokenStream that is allowed to be re-used from the previous time that the same thread called this method. Callers that do not need to use more than one TokenStream at the same time from this analyzer should use this method for better performance.
      Throws:
        `java.io.IOException`

    - #### getPreviousTokenStream

          protected java.lang.Object getPreviousTokenStream()

      Used by Analyzers that implement reusableTokenStream to retrieve previously saved TokenStreams for re-use by the same thread.

    - #### setPreviousTokenStream

          protected void setPreviousTokenStream(java.lang.Object obj)

      Used by Analyzers that implement reusableTokenStream to save a TokenStream for later re-use by the same thread.

    - #### setOverridesTokenStreamMethod

          protected void setOverridesTokenStreamMethod(java.lang.Class baseClass)

      Deprecated. This is only present to preserve back-compat of classes that subclass a core analyzer and override tokenStream but not reusableTokenStream

    - #### getPositionIncrementGap

          public int getPositionIncrementGap(java.lang.String fieldName)

      Invoked before indexing a Fieldable instance if terms have already been added to that field. This allows custom analyzers to place an automatic position increment gap between Fieldable instances using the same field name. The default value position increment gap is 0. With a 0 position increment gap and the typical default token position increment of 1, all terms in a field, including across Fieldable instances, are in successive positions, allowing exact PhraseQuery matches, for instance, across Fieldable instance boundaries.
      Parameters:
        `fieldName` - Fieldable name being indexed.
      Returns:
        position increment gap, added to the next token emitted from `tokenStream(String,Reader)`

    - #### getOffsetGap

          public int getOffsetGap(Fieldable field)

      Just like `getPositionIncrementGap(java.lang.String)`, except for Token offsets instead. By default this returns 1 for tokenized fields and, as if the fields were joined with an extra space character, and 0 for un-tokenized fields. This method is only called if the field produced at least one token for indexing.
      Parameters:
        `field` - the field just indexed
      Returns:
        offset gap, added to the next token emitted from `tokenStream(String,Reader)`

    - #### close

          public void close()

      Frees persistent resources used by this Analyzer

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.